/*******************************************************************************
 * FoxGameObject_Generic generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxGameObject_Generic extends FoxStation_Base
    abstract
    native
    config(Game)
    notplaceable
    hidecategories(Navigation);

var() transient class<FoxMiniGame_Base> MiniGameClass;
var() private export editinline transient DynamicLightEnvironmentComponent LightEnv;
var transient bool bHasBeenHacked;

replication
{
    // Pos:0x000
    if(bNetDirty && Role == ROLE_Authority)
        MiniGameClass
}

protected simulated function OnSuccessfulUse(FoxPawn InteractingPawn)
{
    // End:0xA5
    if((FoxGameMP_PL(WorldInfo.Game) != none) && !bHasBeenHacked)
    {
        bHasBeenHacked = true;
        FoxGameMP_PL(WorldInfo.Game).DoorHacked(InteractingPawn.Controller);
    }
    super.OnSuccessfulUse(InteractingPawn);
    //return;    
}

simulated function PostBeginPlay()
{
    local FoxPC LocalPC;
    local int RandomIndex;

    super(FoxGameObject_Use).PostBeginPlay();
    bHasBeenHacked = false;
    // End:0x70
    if(Role == ROLE_Authority)
    {
        RandomIndex = Rand(MiniGames.Length);
        MiniGameClass = ((MiniGames.Length > 0) ? MiniGames[RandomIndex] : none);
    }
    // End:0xE9
    foreach LocalPlayerControllers(class'FoxPC', LocalPC)
    {
        // End:0xE8
        if(LocalPC.MyFoxHud != none)
        {
            LocalPC.MyFoxHud.AddPostRenderedActor(self);
        }        
    }    
    LightEnv.ResetEnvironment();
    //return;    
}

simulated function SpawnMiniGame(FoxPawn UsingPawn)
{
    local class<FoxHudMiniGameBase> HudMinigameClass;

    HudMinigameClass = MiniGameClass.default.MiniGameUIClass;
    FoxPC(UsingPawn.Controller).MyFoxHud.SpawnMiniGameUI(HudMinigameClass, self);
    //return;    
}

simulated function StartUsingLocal(FoxPawn UsingPawn)
{
    SpawnMiniGame(UsingPawn);
    //return;    
}

simulated function ToggleHRVEffects(const bool bHRVEnabled)
{
    local int I;

    // End:0xB7
    if(bHRVEnabled && bEnabled)
    {
        I = 0;
        J0x27:
        // End:0x93 [Loop If]
        if(I < ObjectMesh.GetNumElements())
        {
            ObjectMesh.SetMaterial(I, HRVMaterial);
            ++ I;
            // [Loop Continue]
            goto J0x27;
        }
        ObjectMesh.SetDepthPriorityGroup(2);
    }
    // End:0x147
    else
    {
        I = 0;
        J0xC2:
        // End:0x126 [Loop If]
        if(I < ObjectMesh.GetNumElements())
        {
            ObjectMesh.SetMaterial(I, none);
            ++ I;
            // [Loop Continue]
            goto J0xC2;
        }
        ObjectMesh.SetDepthPriorityGroup(1);
    }
    //return;    
}

defaultproperties
{
    begin object name=MyLightEnvironment class=DynamicLightEnvironmentComponent
        bCastShadows=false
        bDynamic=false
        bSynthesizeSHLight=true
        bEnabled=false
    object end
    // Reference: DynamicLightEnvironmentComponent'Default__FoxGameObject_Generic.MyLightEnvironment'
    LightEnv=MyLightEnvironment
    bDrawUseText=true
    LocStringSpecUse="HACKING GATE"
    begin object name=NewSM class=StaticMeshComponent
        ReplacementPrimitive=none
        LightEnvironment=DynamicLightEnvironmentComponent'Default__FoxGameObject_Generic.MyLightEnvironment'
        bCastDynamicShadow=false
        bUsePrecomputedShadows=true
    object end
    // Reference: StaticMeshComponent'Default__FoxGameObject_Generic.NewSM'
    ObjectMesh=NewSM
    Components(0)=none
    begin object name=MyLightEnvironment class=DynamicLightEnvironmentComponent
        bCastShadows=false
        bDynamic=false
        bSynthesizeSHLight=true
        bEnabled=false
    object end
    // Reference: DynamicLightEnvironmentComponent'Default__FoxGameObject_Generic.MyLightEnvironment'
    Components(1)=MyLightEnvironment
    begin object name=NewSM class=StaticMeshComponent
        ReplacementPrimitive=none
        LightEnvironment=DynamicLightEnvironmentComponent'Default__FoxGameObject_Generic.MyLightEnvironment'
        bCastDynamicShadow=false
        bUsePrecomputedShadows=true
    object end
    // Reference: StaticMeshComponent'Default__FoxGameObject_Generic.NewSM'
    Components(2)=NewSM
    begin object name=NewSM class=StaticMeshComponent
        ReplacementPrimitive=none
        LightEnvironment=DynamicLightEnvironmentComponent'Default__FoxGameObject_Generic.MyLightEnvironment'
        bCastDynamicShadow=false
        bUsePrecomputedShadows=true
    object end
    // Reference: StaticMeshComponent'Default__FoxGameObject_Generic.NewSM'
    CollisionComponent=NewSM
}